//Készítette:    Veszprémi Anna
//Dátum:         2018.02.20.
//Prioritásos sor forrás kódja

#include "priorsor.h"

using namespace std;

PrSor::PrSor()
{
    _h=0; _n=size;
    _vec= new Elem[_n];
}

PrSor::PrSor(int m)
{
    if(m<=0) throw HIBAS_MERET;
    _h=0; _n=m;
    _vec=new Elem[_n];
}

void PrSor::prSorba(Elem a)
{
    _vec[_h++]=a;
}

Elem PrSor::maxKivesz()
{
    if(_h==0) throw URES_PRSOR;
    //...
}

Elem PrSor::max() const
{
    if(_h==0) throw URES_PRSOR;
    //...
}

ostream& operator<<(std::ostream& s, const PrSor& q)
{
    s << "\n>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>\n";
    s << "PrSor jellemzoi:\n";
    s << "A sor merete:" << q._n << " Elemszam:" << q._h << "\nTartalma: " << endl;
    for(int i = 0; i < q._h; ++i){
        s << " (" << q._vec[i].pr << "," << q._vec[i].adat << ")";
    }
    s << "\n>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>\n\n";
    return s;
}

PrSor::PrSor(const PrSor& q)
{
    // deep copy készítés
}

PrSor& PrSor::operator=(const PrSor& q)
{
    // deep copy készítés
    // Vigyázat: önmagának értékadás
}

int PrSor::maxindex() const
{
    // sima maxker prioritás szerint
}

vector<Elem> PrSor::getElemek() const
{
    vector<Elem> v;
    for(int i=0; i<_h; ++i)
        v.push_back(_vec[i]);
    return v;
}
